#version 140
struct Material {           // structure that describes currently used material
  vec3  ambient;            // ambient component
  vec3  diffuse;            // diffuse component
  vec3  specular;           // specular component
  float shininess;          // sharpness of specular reflection

  bool  useTexture;         // defines whether the texture is used or not
};

uniform Material material;
uniform sampler2D texSampler; 

uniform bool isFog;

in vec4 color_v;
in vec2 texCoord_v;
in float distanceFog; 

out vec4       color_f;

//exponencial fog
float fog() {
		float density = 0.70;
		float e = 2.718281828;
		float z = distanceFog;
		return pow(e, -density * z);
}

void main() {

    color_f = color_v;

    if(material.useTexture == true)
        color_f =  color_v * texture(texSampler, texCoord_v);

    if (isFog) {
			color_f = fog() * color_f + (1 - fog()) * vec4(0.7, 0.7, 0.7, 1.0);
		}
}
