#version 140

uniform sampler2D texSampler;  // sampler for texture access

smooth in vec2 texCoord_v;     // incoming fragment texture coordinates
out vec4 color_f;    // outgoing fragment color

uniform bool isFog;

in float distanceFog; 

//exponencial fog
float fog() {
		float density = 0.70;
		float e = 2.718281828;
		float z = distanceFog;
		return pow(e, -density * z);
}

void main() {

  // fragment color is given only by the texture
  color_f = texture(texSampler, texCoord_v);

  if (isFog) {
			color_f = fog() * color_f + (1 - fog()) * vec4(0.7, 0.7, 0.7, 0.0);
		}
}
